【优选算法】(第十五篇)

目录

和为k的⼦数组(medium)

题目解析

讲解算法原理

编写代码

和可被K整除的⼦数组(medium)

题目解析

讲解算法原理

编写代码


和为k的⼦数组(medium)

题目解析

1.题目链接:. - 力扣(LeetCode)

2.题目描述

给你⼀个整数数组nums和⼀个整数k,请你统计并返回该数组中和为k的连续⼦数组的个数。

⽰例1:

输⼊:nums=1,1,1,k=2

输出:2

⽰例2:

输⼊:nums=1,2,3,k=3

输出:2

提⽰:

1<=nums.length<=2*10^4

-1000<=numsi<=1000

-10^7<=k<=10^7

讲解算法原理

解法⼀(将前缀和存在哈希表中):

算法思路:

设 i 为数组中的任意位置,⽤ sumi 表⽰ 0, i 区间内所有元素的和。

想知道有多少个「以 i 为结尾的和为 k 的⼦数组」,就要找到有多少个起始位置为 x1, x2, x3... 使得 x, i 区间内的所有元素的和为 k 。那么 0, x 区间内的和是不是就是

sumi - k 了。于是问题就变成:

◦ 找到在 0, i - 1 区间内,有多少前缀和等于 sumi - k 的即可。

我们不⽤真的初始化⼀个前缀和数组,因为我们只关⼼在 i 位置之前,有多少个前缀和等于

sumi - k 。因此,我们仅需⽤⼀个哈希表,⼀边求当前位置的前缀和,⼀边存下之前每⼀种

前缀和出现的次数。

编写代码

c++算法代码:

复制代码
class Solution
{
public:
 int subarraySum(vector<int>& nums, int k) 
 {
 unordered_map<int, int> hash; // 统计前缀和出现的次数
 hash[0] = 1;
 int sum = 0, ret = 0;
 for(auto x : nums)
 {
 sum += x; // 计算当前位置的前缀和
 if(hash.count(sum - k)) ret += hash[sum - k]; // 统计个数
 hash[sum]++;
 }
 return ret;
 }
};

java算法代码:

复制代码
class Solution {
 public int subarraySum(int[] nums, int k) {
 Map<Integer, Integer> hash = new HashMap<Integer, Integer>();
 hash.put(0, 1);
 int sum = 0, ret = 0;
 for(int x : nums)
 {
 sum += x; // 计算当前位置的前缀和
 ret += hash.getOrDefault(sum - k, 0); // 统计结果
 hash.put(sum, hash.getOrDefault(sum, 0) + 1); // 把当前的前缀和丢到哈希表⾥⾯
 }
 return ret;
 }
}

和可被K整除的⼦数组(medium)

题目解析

(本题是某一年蓝桥杯竞赛原题)

1.题目链接:. - 力扣(LeetCode)

2。题目描述

给定⼀个整数数组nums和⼀个整数k,返回其中元素之和可被k整除的(连续、⾮空)⼦数组的数⽬。

⼦数组是数组的连续部分。

⽰例1:

输⼊:

nums=4,5,0,-2,-3,1,k=5

输出:

7

解释:

有7个⼦数组满⾜其元素之和可被k=5整除:

4,5,0,-2,-3,1\],\[5\],\[5,0\],\[5,0,-2,-3\],\[0\],\[0,-2,-3\],\[-2,-3

⽰例2:

输⼊:

nums=5,k=9

输出:

0

提⽰:

1<=nums.length<=3*104

-104<=numsi<=104

2<=k<=104

讲解算法原理

解法(前缀和在哈希表中):
(暴⼒解法就是枚举出所有的⼦数组的和,这⾥不再赘述。)

本题需要的前置知识:

• 同余定理

如果 (a - b) % n == 0 ,那么我们可以得到⼀个结论: a % n == b % n 。⽤⽂字叙述就是,如果两个数相减的差能被n整除,那么这两个数对n取模的结果相同。

例如: (26 - 2) % 12 == 0 ,那么 26 % 12 == 2 % 12 == 2 。

• c++ 中负数取模的结果,以及如何修正「负数取模」的结果

a. c++ 中关于负数的取模运算,结果是「把负数当成正数,取模之后的结果加上⼀个负号」。

例如: -1 % 3 = -(1 % 3) = -1

b. 因为有负数,为了防⽌发⽣「出现负数」的结果,以 (a % n + n) % n 的形式输出保证为

正。

例如: -1 % 3 = (-1 % 3 + 3) % 3 = 2

算法思路:
思路与560.和为K的⼦数组这道题的思路相似。

设 i 为数组中的任意位置,⽤ sumi 表⽰ 0, i 区间内所有元素的和。

• 想知道有多少个「以 i 为结尾的可被 k 整除的⼦数组」,就要找到有多少个起始位置为 x1,

x2, x3... 使得 x, i 区间内的所有元素的和可被 k 整除。

• 设 0, x - 1 区间内所有元素之和等于 a , 0, i 区间内所有元素的和等于 b ,可得

(b - a) % k == 0 。

• 由同余定理可得, 0, x - 1 区间与 0, i 区间内的前缀和同余。于是问题就变成:

◦ 找到在 0, i - 1 区间内,有多少前缀和的余数等于 sumi % k 的即可。

我们不⽤真的初始化⼀个前缀和数组,因为我们只关⼼在 i 位置之前,有多少个前缀和等于

sumi - k 。因此,我们仅需⽤⼀个哈希表,⼀边求当前位置的前缀和,⼀边存下之前每⼀种前

缀和出现的次数。

编写代码

c++算法代码:

复制代码
class Solution
{
public:
 int subarraysDivByK(vector<int>& nums, int k) 
 {
 unordered_map<int, int> hash;
 hash[0 % k] = 1; // 0 这个数的余数
 int sum = 0, ret = 0;
 for(auto x : nums)
 {
 sum += x; // 算出当前位置的前缀和
 int r = (sum % k + k) % k; // 修正后的余数
 if(hash.count(r)) ret += hash[r]; // 统计结果
 hash[r]++;
 }
 return ret;
 }
};

java算法原理:

复制代码
class Solution {
 public int subarraysDivByK(int[] nums, int k) {
 Map<Integer, Integer> hash = new HashMap<Integer, Integer>();
 hash.put(0 % k, 1);
 int sum = 0, ret = 0;
 for(int x : nums)
 {
 sum += x; // 计算当前位置的前缀和
 int r = (sum % k + k) % k;
 ret += hash.getOrDefault(r, 0); // 统计结果
 hash.put(r, hash.getOrDefault(r, 0) + 1);
 }
 return ret;
 }
}
相关推荐
residual_fan5 小时前
船用柴油机动态机动工况故障诊断:控制感知仿射网络(CAAN)的技术实现
人工智能·算法·数据挖掘·数据分析
syagain_zsx5 小时前
BRpc 二次封装:Channel 管理、服务管理与回调工厂
c++·学习·程序人生·rpc·谷歌
其实防守也摸鱼5 小时前
Cylab在线靶场——CTF中的通用技能
linux·数据库·学习·算法·靶场·ctf·学习网络安全
我命由我123455 小时前
Python 开发 - Python 的 pathlib
java·开发语言·后端·python·学习·java-ee·学习方法
蓝悦无人机5 小时前
《Planning algorithms》读书笔记——第8章 反馈运动规划
算法·读书笔记·反馈运动规划
RaaS1006 小时前
Agent Skills 进了 Linux Foundation:2.8 亿次安装,但装 skill 还没有安全规范
人工智能·算法·架构
苜蓿muxu6 小时前
Java 字符串拼接:+、StringBuilder、StringBuffer的区别
java
摇滚侠6 小时前
《Java并发编程之美》第 4 章 Java 并发包中原子操作类原理剖析 阅读笔记 7
java·笔记·python
CV爱数码6 小时前
CT 重建从零开始(五):ASTRA Toolbox 上手——几何、投影器与算法
图像处理·算法·计算机视觉·ct
TunerT_TQ6 小时前
超立方体Ramsey(openai/math 家族171)H11攻坚日志|D60–D69:Star分组重数、二幂坐标群、奇偶入射语义与Site‑Level候选计数形式化闭环
算法